Index: /trunk/sources/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/TemperatureController.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/TemperatureController.cs	(revision 15295)
+++ /trunk/sources/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/TemperatureController.cs	(revision 15295)
@@ -0,0 +1,144 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+using System.Linq;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Optimization;
+
+namespace HeuristicLab.Algorithms.SimulatedAnnealing
+{
+    [Item("TemperatureController", "Responsible to first initialize the temperature and then control the temperature.")]
+    [StorableClass]
+    public class TemperatureController : SingleSuccessorOperator
+    {
+        #region Strings
+        private const string ReheatingOperatorName = "ReheatingOperator";
+        private const string AnnealingOperatorName = "AnnealingOperator";
+        private const string MaximumIterationsName = "MaximumIterations";
+        private const string InitialTemperatureName = "InitialTemperature";
+        private const string LowerTemperatureName = "LowerTemperature";
+        private const string IterationsName = "Iterations";
+        private const string TemperatureStartIndexName = "TemperatureStartIndex";
+        private const string CoolingName = "Cooling";
+        private const string StartTemperatureName = "StartTemperature";
+        private const string EndTemperatureName = "EndTemperature";
+        private const string TemperatureName = "Temperature";
+        private const string IsAcceptedName = "IsAccepted";
+        private const string ConsecutiveRejectedSolutionsCountName = "ConsecutiveRejectedSolutions";
+        private const string AverageAcceptanceRatioName = "AverageAcceptanceRatio";
+        private const string AcceptanceMemoryName = "AcceptanceMemory";
+        private const string LastQualityName = "LastQuality";
+        private const string UphillMovesMemoryName = "UphillMovesMemory";
+        private const string MaximizationName = "Maximization";
+        private const string MoveQualityName = "MoveQuality";
+        private const string TemperatureBeforeReheatName = "TemperatureBeforeReheat";
+        private const string CurrentRandomWalkStepName = "CurrentRandomWalkStep";
+        private const string QualitiesBeforeReheatingName = "QualitiesBeforeReheating";
+        private const string LastAcceptedQualityName = "LastAcceptedQuality";
+        private const string TemperatureInitializerName = "TemperatureInitializer";
+        private const string TemperatureInitializedName = "TemperatureInitialized";
+        #endregion
+
+        #region Parameter Properties
+        public IValueLookupParameter<IReheatingOperator> ReheatingOperatorParameter
+        {
+            get { return (IValueLookupParameter<IReheatingOperator>)Parameters[ReheatingOperatorName]; }
+        }
+        public IValueLookupParameter<ITemperatureInitializer> TemperatureInitializerParameter
+        {
+            get { return (IValueLookupParameter<ITemperatureInitializer>)Parameters[TemperatureInitializerName]; }
+        }
+        public ILookupParameter<BoolValue> TemperatureInitializedParameter
+        {
+            get { return (ILookupParameter<BoolValue>)Parameters[TemperatureInitializedName]; }
+        }
+        #endregion
+
+        [StorableConstructor]
+        protected TemperatureController(bool deserializing) : base(deserializing) { }
+        protected TemperatureController(TemperatureController original, Cloner cloner) : base(original, cloner) { }
+        public TemperatureController()
+          : base()
+        {
+            Parameters.Add(new LookupParameter<DoubleValue>(TemperatureName, "The current temperature."));
+            Parameters.Add(new ValueLookupParameter<DoubleValue>(LowerTemperatureName, "The lower bound of the temperature."));
+            Parameters.Add(new LookupParameter<IntValue>(IterationsName, "The number of iterations."));
+            Parameters.Add(new ValueLookupParameter<IntValue>(MaximumIterationsName, "The maximum number of iterations which should be processed."));
+            Parameters.Add(new ValueLookupParameter<BoolValue>(MaximizationName, "True if the problem is a maximization problem, otherwise false."));
+            Parameters.Add(new ValueLookupParameter<IOperator>(AnnealingOperatorName, "The operator that cools the temperature."));
+            Parameters.Add(new ValueLookupParameter<IReheatingOperator>(ReheatingOperatorName, "The operator that reheats the temperature if necessary."));
+            Parameters.Add(new LookupParameter<IntValue>(TemperatureStartIndexName, "The index where the annealing or heating was last changed."));
+            Parameters.Add(new LookupParameter<BoolValue>(CoolingName, "True when the temperature should be cooled, false otherwise."));
+            Parameters.Add(new LookupParameter<DoubleValue>(StartTemperatureName, "The temperature from which cooling or reheating should occur."));
+            Parameters.Add(new LookupParameter<DoubleValue>(EndTemperatureName, "The temperature to which should be cooled or heated."));
+            Parameters.Add(new LookupParameter<BoolValue>(IsAcceptedName, "Whether the move was accepted or not."));
+            Parameters.Add(new LookupParameter<ItemList<BoolValue>>(AcceptanceMemoryName, "Memorizes the last N acceptance decisions."));
+            Parameters.Add(new LookupParameter<DoubleValue>(InitialTemperatureName, "The initial temperature."));
+
+            Parameters.Add(new LookupParameter<ItemList<DoubleValue>>(UphillMovesMemoryName, "Memorizes the last 100 uphill moves."));
+            Parameters.Add(new LookupParameter<DoubleValue>(MoveQualityName, "The value which represents the quality of a move."));
+            Parameters.Add(new LookupParameter<DoubleValue>(LastQualityName, "The value which represents the quality of the last move."));
+            Parameters.Add(new LookupParameter<IntValue>(ConsecutiveRejectedSolutionsCountName, "Amount of consecutive rejected solutions."));
+            Parameters.Add(new LookupParameter<DoubleValue>(AverageAcceptanceRatioName, "Average acceptance over full acceptance memory."));
+            Parameters.Add(new LookupParameter<IntValue>(CurrentRandomWalkStepName, "Current random walk step."));
+            Parameters.Add(new LookupParameter<DoubleValue>(TemperatureBeforeReheatName, "Temperature before the reheat occured."));
+            Parameters.Add(new LookupParameter<ItemList<DoubleValue>>(QualitiesBeforeReheatingName, "List of qualities where the algorithm has been stuck."));
+            Parameters.Add(new LookupParameter<DoubleValue>(LastAcceptedQualityName, "Quality of last accepted solution."));
+
+            Parameters.Add(new ValueLookupParameter<ITemperatureInitializer>(TemperatureInitializerName, "The operator that initilized the temperature."));
+            Parameters.Add(new LookupParameter<BoolValue>(TemperatureInitializedName, "True, if the temperature has already been initialized."));
+
+        }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new TemperatureController(this, cloner);
+        }
+
+        public override IOperation Apply()
+        {
+
+            if (!TemperatureInitializedParameter.ActualValue.Value)
+            {
+                return new OperationCollection
+                {
+                    ExecutionContext.CreateOperation(TemperatureInitializerParameter.ActualValue),
+                    base.Apply()
+                };
+            }
+            else
+            {
+                return new OperationCollection {
+                    ExecutionContext.CreateOperation(ReheatingOperatorParameter.ActualValue),
+                    base.Apply()
+                };
+            }
+        }
+    }
+}
Index: /trunk/sources/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/TemperatureInitializerBasedOnAverageHillsize.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/TemperatureInitializerBasedOnAverageHillsize.cs	(revision 15295)
+++ /trunk/sources/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/TemperatureInitializerBasedOnAverageHillsize.cs	(revision 15295)
@@ -0,0 +1,178 @@
+﻿using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.SimulatedAnnealing
+{
+    /*  Temperature initializer based on Johnson, David S., et al. "Optimization by simulated annealing: an experimental evaluation; part I, graph partitioning." Operations research 37.6 (1989): 865-892.
+     *  http://faculty.washington.edu/aragon/pubs/annealing-pt1.pdf (see Section 5.4, Paragraph 3, Parameter INITPROB)
+     *  
+     *  The initial temperature gets calculated by
+     *      1. Performing a random walk and collection of (UphillMovesMemorySize) amount of hills
+     *      2. Calculating the average hillsize
+     *      3. Define initial temperature as the temperature that lets the algorithm overcome a hill of average size with a percentage of INITIALACCEPTANCERATE
+     */
+
+    [Item("TemperatureInitializerBasedOnAverageHillsize", "Sets the initial temperature to the temperature that initialy lets the algorithm accept an averaged sized hill with a certain probability.")]
+    [StorableClass]
+    public class TemperatureInitializerBasedOnAverageHillsize : SingleSuccessorOperator, ITemperatureInitializer
+    {
+        #region Strings
+        private const string InitialTemperatureName = "InitialTemperature";
+        private const string TemperatureInitializedName = "TemperatureInitialized";
+        private const string StartTemperatureName = "StartTemperature";
+        private const string TemperatureStartIndexName = "TemperatureStartIndex";
+        private const string TemperatureName = "Temperature";
+        private const string IterationsName = "Iterations";
+
+        private const string LastQualityName = "LastQuality";
+        private const string UphillMovesMemoryName = "UphillMovesMemory";
+        private const string UphillMovesMemorySizeName = "UphillMovesMemorySize";
+        private const string MaximizationName = "Maximization";
+        private const string MoveQualityName = "MoveQuality";
+        private const string InitialAcceptanceRateName = "InitialAcceptanceRate";
+
+        private const string ResultsName = "Results";
+
+
+        #endregion
+
+        #region Properties
+        public ILookupParameter<DoubleValue> InitialTemperatureParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[InitialTemperatureName]; }
+        }
+        public ILookupParameter<BoolValue> TemperatureInitializedParameter
+        {
+            get { return (ILookupParameter<BoolValue>)Parameters[TemperatureInitializedName]; }
+        }
+        public ILookupParameter<DoubleValue> StartTemperatureParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[StartTemperatureName]; }
+        }
+        public ILookupParameter<IntValue> TemperatureStartIndexParameter
+        {
+            get { return (ILookupParameter<IntValue>)Parameters[TemperatureStartIndexName]; }
+        }
+        public ILookupParameter<DoubleValue> TemperatureParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[TemperatureName]; }
+        }
+        public ILookupParameter<IntValue> IterationsParameter
+        {
+            get { return (ILookupParameter<IntValue>)Parameters[IterationsName]; }
+        }
+        public ILookupParameter<ItemList<DoubleValue>> UphillMovesMemoryParameter
+        {
+            get { return (ILookupParameter<ItemList<DoubleValue>>)Parameters[UphillMovesMemoryName]; }
+        }
+        public ILookupParameter<DoubleValue> MoveQualityParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[MoveQualityName]; }
+        }
+        public ILookupParameter<DoubleValue> LastQualityParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[LastQualityName]; }
+        }
+        public IValueLookupParameter<BoolValue> MaximizationParameter
+        {
+            get { return (IValueLookupParameter<BoolValue>)Parameters[MaximizationName]; }
+        }
+        public IValueParameter<DoubleValue> InitialAcceptanceRateParameter
+        {
+            get { return (IValueParameter<DoubleValue>)Parameters[InitialAcceptanceRateName]; }
+        }
+        public IValueParameter<IntValue> UphillMovesMemorySizeParameter
+        {
+            get { return (IValueParameter<IntValue>)Parameters[UphillMovesMemorySizeName]; }
+        }
+
+        #endregion
+
+        public TemperatureInitializerBasedOnAverageHillsize() : base()
+        {
+            Parameters.Add(new LookupParameter<DoubleValue>(InitialTemperatureName, "Temporary initial temperature field."));
+            Parameters.Add(new LookupParameter<BoolValue>(TemperatureInitializedName, "True, if the temperature has already been initialized."));
+            Parameters.Add(new LookupParameter<DoubleValue>(StartTemperatureName, "The temperature from which cooling or reheating should occur."));
+            Parameters.Add(new LookupParameter<IntValue>(TemperatureStartIndexName, "The index where the annealing or heating was last changed."));
+            Parameters.Add(new LookupParameter<DoubleValue>(MoveQualityName, "The value which represents the quality of a move."));
+            Parameters.Add(new LookupParameter<DoubleValue>(LastQualityName, "The value which represents the quality of the last move."));
+            Parameters.Add(new LookupParameter<DoubleValue>(TemperatureName, "The current temperature."));
+            Parameters.Add(new ValueLookupParameter<BoolValue>(MaximizationName, "True if the problem is a maximization problem, otherwise false."));
+            Parameters.Add(new LookupParameter<IntValue>(IterationsName, "The number of iterations."));
+            Parameters.Add(new ValueParameter<DoubleValue>(InitialAcceptanceRateName, "The initial acceptance rate of average-sized hills used to calculate the initial temperature.", new DoubleValue(0.001)));
+            Parameters.Add(new ValueParameter<IntValue>(UphillMovesMemorySizeName, "The amount of uphill moves necessary to compute the initial temperature.", new IntValue(100)));
+            Parameters.Add(new LookupParameter<ItemList<DoubleValue>>(UphillMovesMemoryName, "The field that stores the uphill moves."));
+        }
+
+        [StorableConstructor]
+        protected TemperatureInitializerBasedOnAverageHillsize(bool deserializing) : base(deserializing) { }
+        protected TemperatureInitializerBasedOnAverageHillsize(TemperatureInitializerBasedOnAverageHillsize original, Cloner cloner) : base(original, cloner) { }
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new TemperatureInitializerBasedOnAverageHillsize(this, cloner);
+        }
+
+        public override IOperation Apply()
+        {
+            var currentQuality = MoveQualityParameter.ActualValue.Value;
+            var lastQuality = LastQualityParameter.ActualValue.Value;
+            var isMaximation = MaximizationParameter.ActualValue.Value;
+            var hillMemory = UphillMovesMemoryParameter.ActualValue;
+
+            if (lastQuality != -1)
+            {
+                double hillSize = CalculateHillSize(lastQuality, currentQuality, isMaximation);
+                
+                // if there was an uphill move
+                if (hillSize > 0)
+                {
+                    // add it to the list
+                    hillMemory.Add(new DoubleValue(hillSize));
+                    
+                    // if enough hills have been collected
+                    if (hillMemory.Count >= UphillMovesMemorySizeParameter.Value.Value)
+                    {
+                        // calculate and set initial temperature
+                        var initialTemperature = CalculateInitialTemperatureBasedOnAverageHillSize(hillMemory);
+                        InitialTemperatureParameter.ActualValue.Value = initialTemperature;
+                        TemperatureParameter.ActualValue.Value = initialTemperature;
+                        TemperatureStartIndexParameter.ActualValue.Value = Math.Max(0, IterationsParameter.ActualValue.Value - 1);
+                        StartTemperatureParameter.ActualValue.Value = TemperatureParameter.ActualValue.Value;
+
+                        var results = (ResultCollection)ExecutionContext.Parent.Scope.Variables[ResultsName].Value;
+                        results.Add(new Result(InitialTemperatureName, new DoubleValue(initialTemperature)));
+
+                        // indicate that initial temperature is now set
+                        TemperatureInitializedParameter.ActualValue.Value = true;
+                    }
+                }
+            }
+
+            LastQualityParameter.ActualValue.Value = currentQuality;
+            return base.Apply();
+        }
+
+        private double CalculateInitialTemperatureBasedOnAverageHillSize(ItemList<DoubleValue> hillMemory)
+        {
+            var averageHillSize = hillMemory.Average(x => x.Value);
+            return -(averageHillSize / Math.Log(InitialAcceptanceRateParameter.Value.Value));
+
+        }
+
+        private double CalculateHillSize(double lastQuality, double currentQuality, bool isMaximation)
+        {
+            return isMaximation ? lastQuality - currentQuality : currentQuality - lastQuality;
+        }
+    }
+}
Index: /trunk/sources/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/ValueTemperatureInitializer.cs
===================================================================
--- /trunk/sources/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/ValueTemperatureInitializer.cs	(revision 15295)
+++ /trunk/sources/HeuristicLab.Algorithms.SimulatedAnnealing/3.3/ValueTemperatureInitializer.cs	(revision 15295)
@@ -0,0 +1,96 @@
+﻿using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Threading.Tasks;
+
+namespace HeuristicLab.Algorithms.SimulatedAnnealing
+{
+    [Item("BasicTemperatureInitializer", "Sets the initial temperature to a fixed value.")]
+    [StorableClass]
+    public class BasicTemperatureInitializer : SingleSuccessorOperator, ITemperatureInitializer
+    {
+        #region Strings
+        private const string InitialTemperatureName = "InitialTemperature";
+        private const string TemperatureInitializedName = "TemperatureInitialized";
+        private const string InitialTemperatureSetterName = "InitialTemperatureValue";
+        private const string StartTemperatureName = "StartTemperature";
+        private const string TemperatureStartIndexName = "TemperatureStartIndex";
+        private const string TemperatureName = "Temperature";
+        private const string IterationsName = "Iterations";
+        #endregion
+
+        #region Properties
+        public ILookupParameter<DoubleValue> InitialTemperatureParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[InitialTemperatureName]; }
+        }
+        public ILookupParameter<BoolValue> TemperatureInitializedParameter
+        {
+            get { return (ILookupParameter<BoolValue>)Parameters[TemperatureInitializedName]; }
+        }
+        public IValueParameter<DoubleValue> InitialTemperatureSetterParameter
+        {
+            get { return (IValueParameter<DoubleValue>)Parameters[InitialTemperatureSetterName]; }
+        }
+        public ILookupParameter<DoubleValue> StartTemperatureParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[StartTemperatureName]; }
+        }
+        public ILookupParameter<IntValue> TemperatureStartIndexParameter
+        {
+            get { return (ILookupParameter<IntValue>)Parameters[TemperatureStartIndexName]; }
+        }
+        public ILookupParameter<DoubleValue> TemperatureParameter
+        {
+            get { return (ILookupParameter<DoubleValue>)Parameters[TemperatureName]; }
+        }
+        public ILookupParameter<IntValue> IterationsParameter
+        {
+            get { return (ILookupParameter<IntValue>)Parameters[IterationsName]; }
+        }
+
+        #endregion
+
+        public BasicTemperatureInitializer() : base()
+        {
+            Parameters.Add(new LookupParameter<DoubleValue>(InitialTemperatureName, "Temporary initial temperature field."));
+            Parameters.Add(new ValueParameter<DoubleValue>(InitialTemperatureSetterName, "Sets the initial temperature to this value", new DoubleValue(100)));
+            Parameters.Add(new LookupParameter<BoolValue>(TemperatureInitializedName, "True, if the temperature has already been initialized."));
+            Parameters.Add(new LookupParameter<DoubleValue>(StartTemperatureName, "The temperature from which cooling or reheating should occur."));
+            Parameters.Add(new LookupParameter<IntValue>(TemperatureStartIndexName, "The index where the annealing or heating was last changed."));
+            Parameters.Add(new LookupParameter<DoubleValue>(TemperatureName, "The current temperature."));
+            Parameters.Add(new LookupParameter<IntValue>(IterationsName, "The number of iterations."));
+        }
+
+        [StorableConstructor]
+        protected BasicTemperatureInitializer(bool deserializing) : base(deserializing) { }
+        protected BasicTemperatureInitializer(BasicTemperatureInitializer original, Cloner cloner) : base(original, cloner) { }
+
+
+        public override IDeepCloneable Clone(Cloner cloner)
+        {
+            return new BasicTemperatureInitializer(this, cloner);
+        }
+
+        public override IOperation Apply()
+        {
+            // set temperature to selected value
+            InitialTemperatureParameter.ActualValue.Value = InitialTemperatureSetterParameter.Value.Value;
+            TemperatureParameter.ActualValue.Value = InitialTemperatureSetterParameter.Value.Value;
+            TemperatureStartIndexParameter.ActualValue.Value = Math.Max(0, IterationsParameter.ActualValue.Value - 1);
+            StartTemperatureParameter.ActualValue.Value = TemperatureParameter.ActualValue.Value;
+
+            // indicate that initial temperature is now set
+            TemperatureInitializedParameter.ActualValue.Value = true;
+
+            return base.Apply();
+        }
+    }
+}
